#include "stdafx.h"
#include "TextureClass.h"
#include "texturemanagerclass.h"


TextureManagerClass::TextureManagerClass()
{
}


TextureManagerClass::TextureManagerClass(const TextureManagerClass& other)
{
}


TextureManagerClass::~TextureManagerClass()
{
}


bool TextureManagerClass::Initialize(int count)
{
	m_textureCount = count;

	// Į ؽó ü Ѵ.
	m_TextureArray = new TextureClass[m_textureCount];
	if(!m_TextureArray)
	{
		return false;
	}

	return true;
}


void TextureManagerClass::Shutdown()
{
	// ؽó Ʈ Ѵ.
	if(m_TextureArray)
	{
		for(int i=0; i<m_textureCount; i++)
		{
			m_TextureArray[i].Shutdown();
		}

		delete [] m_TextureArray;
		m_TextureArray = 0;
	}
}


bool TextureManagerClass::LoadTexture(ID3D11Device* device, ID3D11DeviceContext* deviceContext, const char* filename, int location)
{
	// ÷ ؽó Ʈ ʱȭѴ.
	if(!m_TextureArray[location].Initialize(device, deviceContext, filename))
	{
		return false;
	}

	return true;
}


ID3D11ShaderResourceView* TextureManagerClass::GetTexture(int id)
{
	return m_TextureArray[id].GetTexture();
}