#include "stdafx.h"
#include "TimerClass.h"


TimerClass::TimerClass()
{
}


TimerClass::TimerClass(const TimerClass& other)
{
}


TimerClass::~TimerClass()
{
}


bool TimerClass::Initialize()
{
	INT64 frequency = 0;
	
	//  ý  Ÿ̸Ӹ ϴ ȮϽʽÿ.
	QueryPerformanceFrequency((LARGE_INTEGER*)&frequency);
	if (frequency == 0)
	{
		return false;
	}
	
	// ε Ҽ մϴ.
	m_frequency = (float)frequency;

	QueryPerformanceCounter((LARGE_INTEGER*)&m_startTime);

	return true;
}


void TimerClass::Frame()
{
	INT64 currentTime = 0;
	INT64 elapsedTicks = 0;

	QueryPerformanceCounter((LARGE_INTEGER*)&currentTime);

	//  ð      ð ̸ մϴ.
	elapsedTicks = currentTime - m_startTime;

	//  ð մϴ.
	m_frameTime = (float)elapsedTicks / m_frequency;

	m_startTime = currentTime;
}


float TimerClass::GetTime()
{
	return m_frameTime;
}


void TimerClass::StartTimer()
{
	QueryPerformanceCounter((LARGE_INTEGER*)&m_beginTime);
}


void TimerClass::StopTimer()
{
	QueryPerformanceCounter((LARGE_INTEGER*)&m_endTime);
}


int TimerClass::GetTiming()
{
	float elapsedTicks = 0.0f;
	INT64 frequency = 0;
	float milliseconds = 0.0f;


	//   ƽ   ɴϴ.
	elapsedTicks = (float)(m_endTime - m_beginTime);

	// Ÿ̸ ʴ ƽ ӵ ɴϴ.
	QueryPerformanceFrequency((LARGE_INTEGER*)&frequency);

	//  ð и   մϴ.
	milliseconds = (elapsedTicks / (float)frequency) * 1000.0f;

	return (int)milliseconds;
}